clear all; close all;
load H.mat; %chargement de la matrice data contenant f et H(jw) en colonnes
f=data(:,1);
H=data(:,2);
% % RATIONAL FRACTION METHOD
% % simple loop used to display multiple. n of interest is found
% % to be 5 in this freq. range (0-500Hz). (5 modes)
n=5;

% 
figure
semilogy(f,abs(H));%affichage log en ordonne
xlabel('Frequency (Hz)')
ylabel('Inertance Amplitude')


[num den] = invfreqs(H,f*(2*pi),2*n,2*n);%  estime H(jw) comme une fonction rationnelle en p=jw
[residuals poles direct_term] = residue(num,den); %calcule la decomposition en elements simples 
% comme une somme de resonateur 1ddl (pole complexe conjugu)
% 
poles=poles([3:4 7:10]);% choix des poles pour les 3 resonances les plus importantes
n=n-2;
%approche dynamique structure
% Natural frequencies
NF = abs(poles(1:2:2*(n)))./(2*pi)
% damped natural frequencies
NFD = imag(poles(1:2:2*(n)))./(2*pi);
% damping ratio
zeta = real(poles(1:2:2*(n)))./(2*pi)./NF

% overlay NF onto plot
 hold on
 semilogy(repmat(NF',[2 1]),repmat([1e-4;1e2],[1 n]),'--k');
% 
% % Rebuild FRF from coefficients: on synthetise une FRF avec les
% parametres identifis
rebuilt= freqs(num,den,(f*(2*pi)));
% % ...and overlay
hold on
semilogy(f,abs(rebuilt),'r');

figure;
%approche systeme
SYS = TF(num,den)
damp(SYS)% parametres modaux identifis
pulsation=NF*2*pi
pzmap(SYS);%carte pole zero
% Results
% NF =
% 
%   130.3029
%    46.1684
%     7.4554
% 
% 
% zeta =
% 
%    -0.0047
%    -0.0055
%    -0.0086
% 
%  
% Transfer function:
%  
% 0.1885 s^10 + 10.9 s^9 + 3.67e005 s^8 + 1.48e007 s^7 + 2.429e011 s^6 + 6.303e012 s^5      
%                                                                                           
%                  + 6.351e016 s^4 + 8.757e017 s^3 + 5.339e021 s^2 + 2.067e022 s - 6.916e023
%                                                                                           
% ------------------------------------------------------------------------------------------
% s^10 + 48.78 s^9 + 1.978e006 s^8 + 6.362e007 s^7 + 1.293e012 s^6 + 2.354e013 s^5          
%                                                                                           
%                  + 3.062e017 s^4 + 2.171e018 s^3 + 1.819e022 s^2 + 1.832e022 s + 3.845e025
%                                                                                           
%  
%                                                          
%         Eigenvalue            Damping     Freq. (rad/s)  
%                                                          
%  -4.05e-001 + 4.68e+001i     8.65e-003      4.68e+001    
%  -4.05e-001 - 4.68e+001i     8.65e-003      4.68e+001    
%  -1.61e+000 + 2.90e+002i     5.53e-003      2.90e+002    
%  -1.61e+000 - 2.90e+002i     5.53e-003      2.90e+002    
%  -4.46e+000 + 6.01e+002i     7.41e-003      6.01e+002    
%  -4.46e+000 - 6.01e+002i     7.41e-003      6.01e+002    
%  -3.84e+000 + 8.19e+002i     4.69e-003      8.19e+002    
%  -3.84e+000 - 8.19e+002i     4.69e-003      8.19e+002    
%  -1.41e+001 + 9.27e+002i     1.52e-002      9.27e+002    
%  -1.41e+001 - 9.27e+002i     1.52e-002      9.27e+002    
%                                                          
% 
% pulsation =
% 
%   818.7171
%   290.0843
%    46.8435
